// SubSuperSetList.java, used for
// JDubiel.java: computer program for pc-set analysis
// by Akira Takaoka, akira.takaoka@columbia.edu
// Copyright (C) 1994-2017 Akira Takaoka
// All rights reserved.





// package jdubielApplication;

import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;


public class SubSuperSetList extends TnTnIType {





    // Make all the sub-sets of a pc-set.
    public int[][] getSubSets(int[] ssSet, int subsetSize) {
		
		//	int[][] combination = new int[126][10];
		int[][] combination = new int[924][10];
		int noOfSubsets = 0;
		int i0 = 0, i1 = 1, i2 = 2, i3 = 3, i4 = 4, i5 = 5;
		int i6 = 6, i7 = 7, i8 = 8, i9 = 9;

		switch (subsetSize) {
		case 1:
			while (i0 < ssSet.length) {
			    combination[noOfSubsets][0] = i0;
			    noOfSubsets++;
			    i0++;
			}
			break;
		case 2:
			while (i1 < ssSet.length) {
				while (i0 < i1) {
					combination[noOfSubsets][0] = i0;
					combination[noOfSubsets][1] = i1;
					noOfSubsets++;
					i0++;
				}
				i0 = 0;
				i1++;
			}
			break;
		case 3:
			while (i2 < ssSet.length) {
				while (i1 < i2) {
					while (i0 < i1) {
						combination[noOfSubsets][0] 
							= i0;
						combination[noOfSubsets][1] 
							= i1;
						combination[noOfSubsets][2] 
							= i2;
						noOfSubsets++;
						i0++;
					}
					i0 = 0;
					i1++;
				}
				i1 = 1;
				i2++;
			}
			break;
		case 4:
			while (i3 < ssSet.length) {
				while (i2 < i3) {
					while (i1 < i2) {
						while (i0 < i1) {
			combination[noOfSubsets][0] = i0;
			combination[noOfSubsets][1] = i1;
			combination[noOfSubsets][2] = i2;
			combination[noOfSubsets][3] = i3;
			noOfSubsets++;
			i0++;
						}
						i0 = 0;
						i1++;
					}
					i1 = 1;
					i2++;
				}
				i2 = 2;
				i3++;
			}
			break;
		case 5:
			while (i4 < ssSet.length) {
				while (i3 < i4) {
					while (i2 < i3) {
						while (i1 < i2) {
							while (i0 < i1) {
			    combination[noOfSubsets][0] = i0;
			    combination[noOfSubsets][1] = i1;
			    combination[noOfSubsets][2] = i2;
			    combination[noOfSubsets][3] = i3;
			    combination[noOfSubsets][4] = i4;
			    noOfSubsets++;
			    i0++;
							}
							i0 = 0;
							i1++;
						}
						i1 = 1;
						i2++;
					}
					i2 = 2;
					i3++;
				}
				i3 = 3;
				i4++;
			}
			break;
		case 6:
			while (i5 < ssSet.length) {
				while (i4 < i5) {
					while (i3 < i4) {
						while (i2 < i3) {
							while (i1 < i2) {
							while (i0 < i1) {
				combination[noOfSubsets][0] = i0;
				combination[noOfSubsets][1] = i1;
				combination[noOfSubsets][2] = i2;
				combination[noOfSubsets][3] = i3;
				combination[noOfSubsets][4] = i4;
				combination[noOfSubsets][5] = i5;
				noOfSubsets++;
				i0++;
							}
							i0 = 0;
							i1++;
							}
							i1 = 1;
							i2++;
						}
						i2 = 2;
						i3++;
					}
					i3 = 3;
					i4++;
				}
				i4 = 4;
				i5++;
			}
			break;
		case 7:
	while (i6 < ssSet.length) {
	    while (i5 < i6) {
		while (i4 < i5) {
		    while (i3 < i4) {
			while (i2 < i3) {
			    while (i1 < i2) {
				while (i0 < i1) {
				    combination[noOfSubsets][0] = i0;
				    combination[noOfSubsets][1] = i1;
				    combination[noOfSubsets][2] = i2;
				    combination[noOfSubsets][3] = i3;
				    combination[noOfSubsets][4] = i4;
				    combination[noOfSubsets][5] = i5;
				    combination[noOfSubsets][6] = i6;
				    noOfSubsets++;
				    i0++;
				}
				i0 = 0;
				i1++;
			    }
			    i1 = 1;
			    i2++;
			}
			i2 = 2;
			i3++;
		    }
		    i3 = 3;
		    i4++;
		}
		i4 = 4;
		i5++;
	    }
	    i5 = 5;
	    i6++;
	}
	break;
    case 8:
	while (i7 < ssSet.length) {
	    while (i6 < i7) {
		while (i5 < i6) {
		    while (i4 < i5) {
			while (i3 < i4) {
			    while (i2 < i3) {
				while (i1 < i2) {
				    while (i0 < i1) {
					combination[noOfSubsets][0] = i0;
					combination[noOfSubsets][1] = i1;
					combination[noOfSubsets][2] = i2;
					combination[noOfSubsets][3] = i3;
					combination[noOfSubsets][4] = i4;
					combination[noOfSubsets][5] = i5;
					combination[noOfSubsets][6] = i6;
					combination[noOfSubsets][7] = i7;
					noOfSubsets++;
					i0++;
				    }
				    i0 = 0;
				    i1++;
				}
				i1 = 1;
				i2++;
			    }
			    i2 = 2;
			    i3++;
			}
			i3 = 3;
			i4++;
		    }
		    i4 = 4;
		    i5++;
		}
		i5 = 5;
		i6++;
	    }
	    i6 = 6;
	    i7++;
	}
	break;
    case 9:
	while (i8 < ssSet.length) {
	    while (i7 < i8) {
		while (i6 < i7) {
		    while (i5 < i6) {
			while (i4 < i5) {
			    while (i3 < i4) {
				while (i2 < i3) {
				    while (i1 < i2) {
					while (i0 < i1) {
					    combination[noOfSubsets][0] = i0;
					    combination[noOfSubsets][1] = i1;
					    combination[noOfSubsets][2] = i2;
					    combination[noOfSubsets][3] = i3;
					    combination[noOfSubsets][4] = i4;
					    combination[noOfSubsets][5] = i5;
					    combination[noOfSubsets][6] = i6;
					    combination[noOfSubsets][7] = i7;
					    combination[noOfSubsets][8] = i8;
					    noOfSubsets++;
					    i0++;
					}
					i0 = 0;
					i1++;
				    }
				    i1 = 1;
				    i2++;
				}
				i2 = 2;
				i3++;
			    }
			    i3 = 3;
			    i4++;
			}
			i4 = 4;
			i5++;
		    }
		    i5 = 5;
		    i6++;
		}
		i6 = 6;
		i7++;
	    }
	    i7 = 7;
	    i8++;
	}
	break;
    case 10:
	while (i9 < ssSet.length) {
	    while (i8 < i9) {
		while (i7 < i8) {
		    while (i6 < i7) {
			while (i5 < i6) {
			    while (i4 < i5) {
				while (i3 < i4) {
				    while (i2 < i3) {
					while (i1 < i2) {
					    while (i0 < i1) {
				              combination[noOfSubsets][0]=i0;
					      combination[noOfSubsets][1]=i1;
					      combination[noOfSubsets][2]=i2;
					      combination[noOfSubsets][3]=i3;
					      combination[noOfSubsets][4]=i4;
					      combination[noOfSubsets][5]=i5;
					      combination[noOfSubsets][6]=i6;
					      combination[noOfSubsets][7]=i7;
					      combination[noOfSubsets][8]=i8;
					      combination[noOfSubsets][9]=i9;
					      noOfSubsets++;
					      i0++;
					    }
					    i0 = 0;
					    i1++;
					}
					i1 = 1;
					i2++;
				    }
				    i2 = 2;
				    i3++;
				}
				i3 = 3;
				i4++;
			    }
			    i4 = 4;
			    i5++;
			}
			i5 = 5;
			i6++;
		    }
		    i6 = 6;
		    i7++;
		}
		i7 = 7;
		i8++;
	    }
	    i8 = 8;
	    i9++;
	}
	break;
    default:
      ;
    }

		int[][] subsets = new int[noOfSubsets][subsetSize];
		
		for (int j = 0; j < noOfSubsets; j++)
		    for (int i = 0; i < subsetSize; i++)
			subsets[j][i] = ssSet[combination[j][i]];

		return subsets;
    }












    // Possible number of combinations of choosing k items out of n items
    // nCk = n!/(k! * (n - k)!)
    public int numOfCombinations(int n, int k) {

	int nmk = n - k;

	if (nmk == 0) {
	    return 1;
	} else {

	    // n!
	    int factorialOfn = n;
	    while (n > 1) {
		n--;
		factorialOfn *= n;
	    }

	    // k!
	    int factorialOfk = k;
	    while (k > 1) {
		k--;
		factorialOfk *= k;
	    }

	    // (n - k)!
	    int factorialOfnmk = nmk;
	    while (nmk > 1) {
		nmk--;
		factorialOfnmk *= nmk;
	    }

	    return factorialOfn / (factorialOfk * factorialOfnmk);
	}
    }








    // Make all the supersets of a pc-set.
    public int[][] getSuperSets(int[] ssSet, int superSetSize) {

	int diff = superSetSize - ssSet.length;

	int[][] superSets;
	if (diff == 0)
	    superSets = new int[1][];
	else
	    superSets = new int[numOfCombinations(12 - ssSet.length, diff)][];
	// numOfCombinations(n, k): nCk = n!/(k! * (n - k)!)

	for (int i = 0; i < superSets.length; i++)
	    superSets[i] = new int[superSetSize];

	int[] diffSet = new int[12 - ssSet.length];
	int k = 0;
	for (int j = 0; j < 12; j++) {
	    boolean same = false;
	    for (int i = 0; i < ssSet.length; i++)
		if (ssSet[i] == j)
		    same = true;

	    if (same != true) {
		diffSet[k] = j;
		k++;
	    }
	}

	int [][] diffSubSets = getSubSets(diffSet, diff);

	for (int j = 0; j < superSets.length; j++) {
	    for (int ii = 0; ii < ssSet.length; ii++)
		superSets[j][ii] = ssSet[ii];

	    for (int ii = 0; ii < diff; ii++)
		superSets[j][ii + ssSet.length] = diffSubSets[j][ii];
	}

	return superSets;
    }











    public String printSubSets(int[] ssSet, int[][] subSets) {
	// ssSet: the original set of the subsets

	StringBuffer subsetList = new StringBuffer();
	Set prm;
	int [] sbArray = new int[subSets[0].length];
	int [] stats;

	switch (sbArray.length) {
	case 3:
	    stats = new int[12];
	    break;
	case 4:
	    stats = new int[29];
	    break;
	case 5:
	    stats = new int[38];
	    break;
	case 6:
	    stats = new int[50];
	    break;
	case 7:
	    stats = new int[38];
	    break;
	case 8:
	    stats = new int[29];
	    break;
	case 9:
	    stats = new int[12];
	    break;
	default:
	    stats = new int[12];
	    break;
	}
	
		
	subsetList.append("\n\n");
	subsetList.append(subSets.length + " subsets of {");
	subsetList.append(pcSetArrayToString(ssSet));
	subsetList.append("}: \n\n");

	subsetList.append( "Subset \tTn/TnI \tM7/M7I \tName\n");
	for (int k = 0; k < subSets.length; k += 4) {
	    for (int i = 0; i < 4; i++) {

		if (k + i == subSets.length)
		    break;

		for (int j = 0; j < subSets[0].length; j++) 
		    sbArray[j] = subSets[k + i][j];


		// Print a subset.
		subsetList.append("{");
		subsetList.append(pcSetArrayToString(sortPcSet(sbArray)));
		subsetList.append("}\t");

			    
		// Print the TnTnI type
		subsetList.append(" [");
		subsetList.append(pcSetArrayToString(returnTnTnIType(sbArray)));
		subsetList.append("]\t");
				

		// Print the M7/m7I.
		subsetList.append("[");
		subsetList.append(pcSetArrayToString(returnTnTnIType(returnMultipliedBy7(sbArray))));
		subsetList.append("]\t");

		
		// Print the Forte name.
		prm = returnPrimeByTnTnI(returnTnTnIType(sbArray));
		subsetList.append(" ");
		subsetList.append(prm.name);
		subsetList.append("\n");


		// Make statistics of distribution of Tn/TnI types.
		switch (sbArray.length) {
		case 3:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime3[ii].name)
			    stats[ii]++;
		    break;
		case 4:
		    for(int ii = 0; ii < 29; ii++)
			if(prm.name == prime4[ii].name)
			    stats[ii]++;
		    break;
		case 5:
		    for(int ii = 0; ii < 38; ii++)
			if(prm.name == prime5[ii].name)
			    stats[ii]++;
		    break;
		case 6:
		    for(int ii = 0; ii < 50; ii++)
			if(prm.name == prime6[ii].name)
			    stats[ii]++;
		    break;
		case 7:
		    for(int ii = 0; ii < 38; ii++)
			if(prm.name == prime7[ii].name)
			    stats[ii]++;
		    break;
		case 8:
		    for(int ii = 0; ii < 29; ii++)
			if(prm.name == prime8[ii].name)
			    stats[ii]++;
		    break;
		case 9:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime9[ii].name)
			    stats[ii]++;
		    break;
		default:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime3[ii].name)
			    stats[ii] = 0;
		    break;
		}
	    }
	}

	
	// Print statistics of distribution of Tn/TnI types.
	subsetList.append("\n");
	subsetList.append(
		  "Frequency distribution of the Tn/TnI subsets:\n\n");

	switch (sbArray.length) {
	case 3:
	    for(int ii = 0; ii < 12; ii++) {
		subsetList.append(prime3[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 4:
	    for(int ii = 0; ii < 29; ii++) {
		subsetList.append(prime4[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 5:
	    for(int ii = 0; ii < 38; ii++) {
		subsetList.append(prime5[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 6:
	    for(int ii = 0; ii < 50; ii++) {
		subsetList.append(prime6[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 7:
	    for(int ii = 0; ii < 38; ii++) {
		subsetList.append(prime7[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 8:
	    for(int ii = 0; ii < 29; ii++) {
		subsetList.append(prime8[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	case 9:
	    for(int ii = 0; ii < 12; ii++) {
		subsetList.append(prime9[ii].name + ": ");
		subsetList.append(stats[ii] + "\n");
	    }
	    break;
	default:
	    break;
	}
	
	return subsetList.toString();
    }








    // superSets: super sets of ssSet
    public String printSuperSets(int[] ssSet, int[][] superSets) {

	StringBuffer superSetList = new StringBuffer();
	Set prm;
	int [] sbArray = new int[superSets[0].length];
	int [] stats;

	switch (sbArray.length) {
	case 3:
	    stats = new int[12];
	    break;
	case 4:
	    stats = new int[29];
	    break;
	case 5:
	    stats = new int[38];
	    break;
	case 6:
	    stats = new int[50];
	    break;
	case 7:
	    stats = new int[38];
	    break;
	case 8:
	    stats = new int[29];
	    break;
	case 9:
	    stats = new int[12];
	    break;
	default:
	    stats = new int[12];
	    break;
	}
	
		
	superSetList.append("\n\n");
	superSetList.append(superSets.length + " supersets of {");
	superSetList.append(pcSetArrayToString(ssSet));
	superSetList.append("}: \n\n");

	superSetList.append( "Superset \tTn/TnI \tM7/M7I \tName\n");
	for (int k = 0; k < superSets.length; k += 4) {
	    for (int i = 0; i < 4; i++) {

		if (k + i == superSets.length)
		    break;

		for (int j = 0; j < superSets[0].length; j++) 
		    sbArray[j] = superSets[k + i][j];

		// Print a superset.
		superSetList.append("{");
		superSetList.append(pcSetArrayToString(sortPcSet(sbArray)));
		superSetList.append("}\t");
			    
		// Print the TnTnI type
		superSetList.append(" [");
		superSetList.append(pcSetArrayToString(returnTnTnIType(sbArray)));
		superSetList.append("]\t");
				

		// Print the M7/M7I.
		superSetList.append("{");
		superSetList.append(pcSetArrayToString(returnTnTnIType(returnMultipliedBy7(sbArray))));
		superSetList.append("}\t");

		
		// Print the Forte name.
		prm = returnPrimeByTnTnI(returnTnTnIType(sbArray));
		superSetList.append(" ");
		superSetList.append(prm.name);
		superSetList.append("\n");


		// Make statistics of distribution of Tn/TnI types.
		switch (sbArray.length) {
		case 3:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime3[ii].name)
			    stats[ii]++;
		    break;
		case 4:
		    for(int ii = 0; ii < 29; ii++)
			if(prm.name == prime4[ii].name)
			    stats[ii]++;
		    break;
		case 5:
		    for(int ii = 0; ii < 38; ii++)
			if(prm.name == prime5[ii].name)
			    stats[ii]++;
		    break;
		case 6:
		    for(int ii = 0; ii < 50; ii++)
			if(prm.name == prime6[ii].name)
			    stats[ii]++;
		    break;
		case 7:
		    for(int ii = 0; ii < 38; ii++)
			if(prm.name == prime7[ii].name)
			    stats[ii]++;
		    break;
		case 8:
		    for(int ii = 0; ii < 29; ii++)
			if(prm.name == prime8[ii].name)
			    stats[ii]++;
		    break;
		case 9:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime9[ii].name)
			    stats[ii]++;
		    break;
		default:
		    for(int ii = 0; ii < 12; ii++)
			if(prm.name == prime3[ii].name)
			    stats[ii] = 0;
		    break;
		}
	    }
	}

	
	// Print statistics of distribution of Tn/TnI types.
	superSetList.append("\n");
	superSetList.append(
		    "Frequency distribution of the Tn/TnI supersets:\n\n");

	switch (sbArray.length) {
	case 3:
	    for(int ii = 0; ii < 12; ii++) {
		superSetList.append(prime3[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 4:
	    for(int ii = 0; ii < 29; ii++) {
		superSetList.append(prime4[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 5:
	    for(int ii = 0; ii < 38; ii++) {
		superSetList.append(prime5[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 6:
	    for(int ii = 0; ii < 50; ii++) {
		superSetList.append(prime6[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 7:
	    for(int ii = 0; ii < 38; ii++) {
		superSetList.append(prime7[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 8:
	    for(int ii = 0; ii < 29; ii++) {
		superSetList.append(prime8[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	case 9:
	    for(int ii = 0; ii < 12; ii++) {
		superSetList.append(prime9[ii].name + ": ");
		superSetList.append(stats[ii] + "\n");
	    }
	    break;
	default:
	    break;
	}
	
	return superSetList.toString();
    }
}



